// Showcases the pitfalls of the return address's proximity to program data,
// particularly when that data is non--bounds checked vector storage! Who said
// off-by-ones were easy to debug?
//
// Sol Boucher <sboucher@cmu.edu>

static int safe(int a, int b, int c, int d, int e, int f, int g, int h) {
	return a + b + c + d + e + f + g + h;
}

static int unsafe(int a, int b, int c, int d, int e, int f, int g, int h) {
	int res[] = {a, b, c, d, e, f, g, h};
	int last;
	for(int idx = 1; idx <= sizeof res / sizeof *res; ++idx)
		last = res[idx] += res[idx - 1];
	return last;
}

int main(void) {
	int ret = safe(1, 2, 3, 4, 5, 6, 7, 8) == 36;
	ret = ret && unsafe(1, 2, 3, 4, 5, 6, 7, 8) == 36;
	return !ret;
}
