// Demonstration of return-oriented programming. It outputs the addresses of
// some useful gadgets, then allows the user to enter a series of 64-bit hex
// numbers with which the stack should be clobbered. By doing this carefully,
// it is possible to cause the smash_it() function to return something else.
//
// Author: Sol Boucher <sboucher@cmu.edu>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void movb(void);
void popb(void);
void mov91(void);

static unsigned long smash_it(long *stack_top) {
	stack_top -= 2;
	long link = *stack_top;
	char entry[17] = "";

	fgets(entry, sizeof entry, stdin);
	long *stack;
	for(stack = stack_top; strcmp(entry, "\n"); ++stack) {
		*stack = strtol(entry, NULL, 16);
		fgets(entry, sizeof entry, stdin);
	}
	if(*stack_top != link)
		*stack = link;

	return 15213;
}

int main(void) {
	puts("Welcome, Inspector Gadget!");
	puts("");
	puts("Unfortunately, GDB's TUI mode (activated using the 'layout' command)");
	puts("sometimes gets messed up when faced with multi-line program output.");
	puts("If you're experiencing this, try the following workaround:");
	puts(" 1. If the target program is awaiting user input, press Ctrl-C to interrupt it.");
	puts(" 2. Press Ctrl-L to redraw the screen.");
	puts(" 3. Enter the 'continue' command to resume the target.");
	puts(" 4. If you were in the middle of entering a line of input, retype it from the beginning.");
	puts("If that doesn't work, try replacing step (2) with Ctrl-X followed by Ctrl-A to leave the TUI.");
	puts("");
	printf("movb() is at %p\n", movb);
	printf("popb() is at %p\n", popb);
	printf("mov91() is at %p\n", mov91);
	puts("");
	puts("Enter 64-bit hex words with which to clobber the stack, one per line, with a blank line at the end:");

	long stack_beacon;
	printf("smash_it() returned %lu\n", smash_it(&stack_beacon));

	exit(0);
}
